<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:cat="urn:oasis:names:tc:entity:xmlns:xml:catalog"
                exclude-result-prefixes="cat"
                version="1.0">

   <xsl:output indent="yes"/>

   <xsl:param name="catalog"  select="/.."/>
   <xsl:param name="delegate"/>

   <xsl:template match="node()">
      <xsl:copy>
         <xsl:copy-of select="@*"/>
         <xsl:apply-templates/>
      </xsl:copy>
   </xsl:template>

   <xsl:template match="cat:nextCatalog[@catalog = $catalog]"/>
   <xsl:template match="cat:delegateSystem[@catalog = $catalog]"/>
   <xsl:template match="cat:delegateURI[@catalog = $catalog]"/>

   <xsl:template match="cat:catalog">
      <xsl:copy>
         <xsl:copy-of select="@*"/>
         <xsl:apply-templates/>
         <!-- FIXME: I've encountered some problems with delegation.
              Before investing further, I just use nextCatalog
              instead.  TODO: See how to solve that problem... -->
         <xsl:element name="nextCatalog" namespace="urn:oasis:names:tc:entity:xmlns:xml:catalog">
            <xsl:attribute name="catalog" namespace="">
               <xsl:value-of select="$catalog"/>
            </xsl:attribute>
         </xsl:element>
         <!--nextCatalog catalog="{ $catalog }"/-->
         <!--xsl:choose>
            <xsl:when test="exists($delegate)">
               <delegateSystem systemIdStartString="{ $delegate }"
                               catalog="{ $catalog }"/>
               <delegateURI uriStartString="{ $delegate }"
                            catalog="{ $catalog }"/>
            </xsl:when>
            <xsl:otherwise>
               <nextCatalog catalog="{ $catalog }"/>
            </xsl:otherwise>
         </xsl:choose-->
      </xsl:copy>
   </xsl:template>

</xsl:stylesheet>
